/* ----
 * ---- file   : dev.h
 * ---- author : Bastian Spiegel <bs@tkscript.de>
 * ---- legal  : (c) 2013 by Bastian Spiegel. 
 * ----          Distributed under terms of the GNU GENERAL PUBLIC LICENSE (GPL). See 
 * ----          http://www.gnu.org/licenses/licenses.html#GPL or COPYING for further information.
 * ----
 * ---- info   : C64 kernel module. This is part of the "c64_tools" package.
 * ----
 * ---- changed: 11Sep2013, 14Sep2013
 * ----
 * ----
 */

#ifndef __C64_TOOLS_KMOD_DEV_H__
#define __C64_TOOLS_KMOD_DEV_H__


#define C64_DEV_MAJOR  (239u)
#define C64_DEV_MINOR  ( 64u)
#define C64_DEV_NAME   "c64"

#define C64_DEV_MAX_CLIENTS  (16u)


/*
 * (todo) document me
 *
 */
sBool dev_init (void);


/*
 * (todo) document me
 *
 * (note) at the moment this function must be as lightweight as possible since
 *         it is directly called from the mlb irq handler.
 *
 */
void dev_handle_reply (const volatile dsp_msg_t *_msgTo,   /* message from GPP to DSP (for client handle) */
                       const volatile dsp_msg_t *_msgFrom  /* message from DSP to GPP */
                       );


/*
 * (todo) document me
 *
 */
void dev_exit (void);


#endif /* __C64_TOOLS_KMOD_DEV_H__ */
